Index: rtos_arduino/trunk/arduino_lib/libraries/Firmata/examples/StandardFirmataWiFi/wifiConfig.h
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Firmata/examples/StandardFirmataWiFi/wifiConfig.h	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/libraries/Firmata/examples/StandardFirmataWiFi/wifiConfig.h	(revision 224)
@@ -0,0 +1,155 @@
+/*==============================================================================
+ * WIFI CONFIGURATION
+ *
+ * You must configure your particular hardware. Follow the steps below.
+ *
+ * Currently StandardFirmataWiFi is configured as a server. An option to
+ * configure as a client may be added in the future.
+ *============================================================================*/
+
+// STEP 1 [REQUIRED]
+// Uncomment / comment the appropriate set of includes for your hardware (OPTION A, B or C)
+// Option A is enabled by default.
+
+/*
+ * OPTION A: Configure for Arduino WiFi shield
+ *
+ * This will configure StandardFirmataWiFi to use the original WiFi library (deprecated) provided
+ * with the Arduino IDE. It is supported by the Arduino WiFi shield (a discontinued product) and
+ * is compatible with 802.11 B/G networks.
+ *
+ * To configure StandardFirmataWiFi to use the Arduino WiFi shield
+ * leave the #define below uncommented.
+ */
+#define ARDUINO_WIFI_SHIELD
+
+//do not modify these next 4 lines
+#ifdef ARDUINO_WIFI_SHIELD
+#include "utility/WiFiStream.h"
+WiFiStream stream;
+#endif
+
+/*
+ * OPTION B: Configure for WiFi 101
+ *
+ * This will configure StandardFirmataWiFi to use the WiFi101 library, which works with the Arduino WiFi101
+ * shield and devices that have the WiFi101 chip built in (such as the MKR1000). It is compatible
+ * with 802.11 B/G/N networks.
+ *
+ * To enable, uncomment the #define WIFI_101 below and verify the #define values under
+ * options A and C are commented out.
+ *
+ * IMPORTANT: You must have the WiFI 101 library installed. To easily install this library, opent the library manager via:
+ * Arduino IDE Menus: Sketch > Include Library > Manage Libraries > filter search for "WiFi101" > Select the result and click 'install'
+ */
+//#define WIFI_101
+
+//do not modify these next 4 lines
+#ifdef WIFI_101
+#include "utility/WiFi101Stream.h"
+WiFi101Stream stream;
+#endif
+
+/*
+ * OPTION C: Configure for HUZZAH
+ *
+ * HUZZAH is not yet supported, this will be added in a later revision to StandardFirmataWiFi
+ */
+
+//------------------------------
+// TODO
+//------------------------------
+//#define HUZZAH_WIFI
+
+
+// STEP 2 [REQUIRED for all boards and shields]
+// replace this with your wireless network SSID
+char ssid[] = "your_network_name";
+
+// STEP 3 [OPTIONAL for all boards and shields]
+// if you want to use a static IP (v4) address, uncomment the line below. You can also change the IP.
+// if this line is commented out, the WiFi shield will attempt to get an IP from the DHCP server
+// #define STATIC_IP_ADDRESS 192,168,1,113
+
+// STEP 4 [REQUIRED for all boards and shields]
+// define your port number here, you will need this to open a TCP connection to your Arduino
+#define SERVER_PORT 3030
+
+// STEP 5 [REQUIRED for all boards and shields]
+// determine your network security type (OPTION A, B, or C). Option A is the most common, and the default.
+
+
+/*
+ * OPTION A: WPA / WPA2
+ *
+ * WPA is the most common network security type. A passphrase is required to connect to this type.
+ *
+ * To enable, leave #define WIFI_WPA_SECURITY uncommented below, set your wpa_passphrase value appropriately,
+ * and do not uncomment the #define values under options B and C
+ */
+#define WIFI_WPA_SECURITY
+
+#ifdef WIFI_WPA_SECURITY
+char wpa_passphrase[] = "your_wpa_passphrase";
+#endif  //WIFI_WPA_SECURITY
+
+/*
+ * OPTION B: WEP
+ *
+ * WEP is a less common (and regarded as less safe) security type. A WEP key and its associated index are required
+ * to connect to this type.
+ *
+ * To enable, Uncomment the #define below, set your wep_index and wep_key values appropriately, and verify
+ * the #define values under options A and C are commented out.
+ */
+//#define WIFI_WEP_SECURITY
+
+#ifdef WIFI_WEP_SECURITY
+//The wep_index below is a zero-indexed value.
+//Valid indices are [0-3], even if your router/gateway numbers your keys [1-4].
+byte wep_index = 0;
+char wep_key[] = "your_wep_key";
+#endif  //WIFI_WEP_SECURITY
+
+
+/*
+ * OPTION C: Open network (no security)
+ *
+ * Open networks have no security, can be connected to by any device that knows the ssid, and are unsafe.
+ *
+ * To enable, uncomment #define WIFI_NO_SECURITY below and verify the #define values
+ * under options A and B are commented out.
+ */
+//#define WIFI_NO_SECURITY
+
+/*==============================================================================
+ * CONFIGURATION ERROR CHECK (don't change anything here)
+ *============================================================================*/
+
+#if ((defined(ARDUINO_WIFI_SHIELD) && (defined(WIFI_101) || defined(HUZZAH_WIFI))) || (defined(WIFI_101) && defined(HUZZAH_WIFI)))
+#error "you may not define more than one wifi device type in wifiConfig.h."
+#endif //WIFI device type check
+
+#if !(defined(ARDUINO_WIFI_SHIELD) || defined(WIFI_101) || defined(HUZZAH_WIFI))
+#error "you must define a wifi device type in wifiConfig.h."
+#endif
+
+#if ((defined(WIFI_NO_SECURITY) && (defined(WIFI_WEP_SECURITY) || defined(WIFI_WPA_SECURITY))) || (defined(WIFI_WEP_SECURITY) && defined(WIFI_WPA_SECURITY)))
+#error "you may not define more than one security type at the same time in wifiConfig.h."
+#endif  //WIFI_* security define check
+
+#if !(defined(WIFI_NO_SECURITY) || defined(WIFI_WEP_SECURITY) || defined(WIFI_WPA_SECURITY))
+#error "you must define a wifi security type in wifiConfig.h."
+#endif  //WIFI_* security define check
+
+/*==============================================================================
+ * PIN IGNORE MACROS (don't change anything here)
+ *============================================================================*/
+
+// ignore SPI pins, pin 5 (reset WiFi101 shield), pin 7 (WiFi handshake) and pin 10 (WiFi SS)
+// also don't ignore SS pin if it's not pin 10
+// TODO - need to differentiate between Arduino WiFi1 101 Shield and Arduino MKR1000
+#define IS_IGNORE_WIFI101_SHIELD(p)  ((p) == 10 || (IS_PIN_SPI(p) && (p) != SS) || (p) == 5 || (p) == 7)
+
+// ignore SPI pins, pin 4 (SS for SD-Card on WiFi-shield), pin 7 (WiFi handshake) and pin 10 (WiFi SS)
+#define IS_IGNORE_WIFI_SHIELD(p)     ((IS_PIN_SPI(p) || (p) == 4) || (p) == 7 || (p) == 10)
Index: rtos_arduino/trunk/arduino_lib/libraries/Firmata/release.sh
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Firmata/release.sh	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/libraries/Firmata/release.sh	(revision 224)
@@ -0,0 +1,35 @@
+#!/bin/sh
+
+# use this script to package Firmata for distribution
+
+# package for Arduino 1.0.x
+mkdir -p temp/Firmata
+cp -r examples temp/Firmata
+cp -r extras temp/Firmata
+cp -r utility temp/Firmata
+cp Boards.h temp/Firmata
+cp Firmata.cpp temp/Firmata
+cp Firmata.h temp/Firmata
+cp keywords.txt temp/Firmata
+cp readme.md temp/Firmata
+cd temp
+find . -name "*.DS_Store" -type f -delete
+zip -r Firmata.zip ./Firmata/
+cd ..
+mv ./temp/Firmata.zip Firmata-2.5.2.zip
+
+#package for Arduino 1.6.x
+cp library.properties temp/Firmata
+cd temp/Firmata
+mv readme.md ./extras/
+mkdir src
+mv Boards.h ./src/
+mv Firmata.cpp ./src/
+mv Firmata.h ./src/
+mv utility ./src/
+cd ..
+find . -name "*.DS_Store" -type f -delete
+zip -r Firmata.zip ./Firmata/
+cd ..
+mv ./temp/Firmata.zip Arduino-1.6.x-Firmata-2.5.2.zip
+rm -r ./temp
Index: rtos_arduino/trunk/arduino_lib/libraries/Firmata/test/firmata_test/firmata_test.ino
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Firmata/test/firmata_test/firmata_test.ino	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/libraries/Firmata/test/firmata_test/firmata_test.ino	(revision 224)
@@ -0,0 +1,136 @@
+/*
+ * To run this test suite, you must first install the ArduinoUnit library
+ * to your Arduino/libraries/ directory.
+ * You can get ArduinoUnit here: https://github.com/mmurdoch/arduinounit
+ * Download version 2.0 or greater or install it via the Arduino library manager.
+ */
+
+#include <ArduinoUnit.h>
+#include <Firmata.h>
+
+void setup()
+{
+  Serial.begin(9600);
+}
+
+void loop()
+{
+  Test::run();
+}
+
+test(beginPrintsVersion)
+{
+  FakeStream stream;
+
+  Firmata.begin(stream);
+
+  char expected[] = {
+    REPORT_VERSION,
+    FIRMATA_PROTOCOL_MAJOR_VERSION,
+    FIRMATA_PROTOCOL_MINOR_VERSION,
+    0
+  };
+  assertEqual(expected, stream.bytesWritten());
+}
+
+void processMessage(const byte *message, size_t length)
+{
+  FakeStream stream;
+  Firmata.begin(stream);
+
+  for (size_t i = 0; i < length; i++) {
+    stream.nextByte(message[i]);
+    Firmata.processInput();
+  }
+}
+
+byte _digitalPort;
+int _digitalPortValue;
+void writeToDigitalPort(byte port, int value)
+{
+  _digitalPort = port;
+  _digitalPortValue = value;
+}
+
+void setupDigitalPort()
+{
+  _digitalPort = 0;
+  _digitalPortValue = 0;
+}
+
+test(processWriteDigital_0)
+{
+  setupDigitalPort();
+  Firmata.attach(DIGITAL_MESSAGE, writeToDigitalPort);
+
+  byte message[] = { DIGITAL_MESSAGE, 0, 0 };
+  processMessage(message, 3);
+
+  assertEqual(0, _digitalPortValue);
+}
+
+test(processWriteDigital_127)
+{
+  setupDigitalPort();
+  Firmata.attach(DIGITAL_MESSAGE, writeToDigitalPort);
+
+  byte message[] = { DIGITAL_MESSAGE, 127, 0 };
+  processMessage(message, 3);
+
+  assertEqual(127, _digitalPortValue);
+}
+
+test(processWriteDigital_128)
+{
+  setupDigitalPort();
+  Firmata.attach(DIGITAL_MESSAGE, writeToDigitalPort);
+
+  byte message[] = { DIGITAL_MESSAGE, 0, 1 };
+  processMessage(message, 3);
+
+  assertEqual(128, _digitalPortValue);
+}
+
+test(processWriteLargestDigitalValue)
+{
+  setupDigitalPort();
+  Firmata.attach(DIGITAL_MESSAGE, writeToDigitalPort);
+
+  byte message[] = { DIGITAL_MESSAGE, 0x7F, 0x7F };
+  processMessage(message, 3);
+
+  // Maximum of 14 bits can be set (B0011111111111111)
+  assertEqual(0x3FFF, _digitalPortValue);
+}
+
+test(defaultDigitalWritePortIsZero)
+{
+  setupDigitalPort();
+  Firmata.attach(DIGITAL_MESSAGE, writeToDigitalPort);
+
+  byte message[] = { DIGITAL_MESSAGE, 0, 0 };
+  processMessage(message, 3);
+
+  assertEqual(0, _digitalPort);
+}
+
+test(specifiedDigitalWritePort)
+{
+  setupDigitalPort();
+  Firmata.attach(DIGITAL_MESSAGE, writeToDigitalPort);
+
+  byte message[] = { DIGITAL_MESSAGE + 1, 0, 0 };
+  processMessage(message, 3);
+
+  assertEqual(1, _digitalPort);
+}
+
+test(setFirmwareVersionDoesNotLeakMemory)
+{
+  Firmata.setFirmwareVersion(1, 0);
+  int initialMemory = freeMemory();
+
+  Firmata.setFirmwareVersion(1, 0);
+
+  assertEqual(0, initialMemory - freeMemory());
+}
Index: rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/BLEStream.cpp
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/BLEStream.cpp	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/BLEStream.cpp	(revision 224)
@@ -0,0 +1,3 @@
+/*
+ * Implementation is in BLEStream.h to avoid linker issues.
+ */
Index: rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/BLEStream.h
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/BLEStream.h	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/BLEStream.h	(revision 224)
@@ -0,0 +1,243 @@
+/*
+  BLEStream.h
+
+  Based on BLESerial.cpp by Voita Molda
+  https://github.com/sandeepmistry/arduino-BLEPeripheral/blob/master/examples/serial/BLESerial.h
+
+  Last updated April 04th, 2016
+ */
+
+#ifndef _BLE_STREAM_H_
+#define _BLE_STREAM_H_
+
+#include <Arduino.h>
+#if defined(_VARIANT_ARDUINO_101_X_)
+#include <CurieBLE.h>
+#define _MAX_ATTR_DATA_LEN_ BLE_MAX_ATTR_DATA_LEN
+#else
+#include <BLEPeripheral.h>
+#define _MAX_ATTR_DATA_LEN_ BLE_ATTRIBUTE_MAX_VALUE_LENGTH
+#endif
+
+#define BLESTREAM_TXBUFFER_FLUSH_INTERVAL 80
+#define BLESTREAM_MIN_FLUSH_INTERVAL 8 // minimum interval for flushing the TX buffer
+
+// #define BLE_SERIAL_DEBUG
+
+class BLEStream : public BLEPeripheral, public Stream
+{
+  public:
+    BLEStream(unsigned char req = 0, unsigned char rdy = 0, unsigned char rst = 0);
+
+    void begin(...);
+    bool poll();
+    void end();
+    void setFlushInterval(int);
+
+    virtual int available(void);
+    virtual int peek(void);
+    virtual int read(void);
+    virtual void flush(void);
+    virtual size_t write(uint8_t byte);
+    using Print::write;
+    virtual operator bool();
+
+  private:
+    bool _connected;
+    unsigned long _flushed;
+    int _flushInterval;
+    static BLEStream* _instance;
+
+    size_t _rxHead;
+    size_t _rxTail;
+    size_t _rxCount() const;
+    unsigned char _rxBuffer[256];
+    size_t _txCount;
+    unsigned char _txBuffer[_MAX_ATTR_DATA_LEN_];
+
+    BLEService _uartService = BLEService("6E400001-B5A3-F393-E0A9-E50E24DCCA9E");
+    BLEDescriptor _uartNameDescriptor = BLEDescriptor("2901", "UART");
+    BLECharacteristic _rxCharacteristic = BLECharacteristic("6E400002-B5A3-F393-E0A9-E50E24DCCA9E", BLEWriteWithoutResponse, _MAX_ATTR_DATA_LEN_);
+    BLEDescriptor _rxNameDescriptor = BLEDescriptor("2901", "RX - Receive Data (Write)");
+    BLECharacteristic _txCharacteristic = BLECharacteristic("6E400003-B5A3-F393-E0A9-E50E24DCCA9E", BLENotify, _MAX_ATTR_DATA_LEN_);
+    BLEDescriptor _txNameDescriptor = BLEDescriptor("2901", "TX - Transfer Data (Notify)");
+
+    void _received(const unsigned char* data, size_t size);
+    static void _received(BLECentral& /*central*/, BLECharacteristic& rxCharacteristic);
+};
+
+
+/*
+ * BLEStream.cpp
+ * Copied here as a hack to avoid having to install the BLEPeripheral libarary even if it's
+ * not needed.
+ */
+
+BLEStream* BLEStream::_instance = NULL;
+
+BLEStream::BLEStream(unsigned char req, unsigned char rdy, unsigned char rst) :
+#if defined(_VARIANT_ARDUINO_101_X_)
+  BLEPeripheral()
+#else
+  BLEPeripheral(req, rdy, rst)
+#endif
+{
+  this->_txCount = 0;
+  this->_rxHead = this->_rxTail = 0;
+  this->_flushed = 0;
+  this->_flushInterval = BLESTREAM_TXBUFFER_FLUSH_INTERVAL;
+  BLEStream::_instance = this;
+
+  addAttribute(this->_uartService);
+  addAttribute(this->_uartNameDescriptor);
+  setAdvertisedServiceUuid(this->_uartService.uuid());
+  addAttribute(this->_rxCharacteristic);
+  addAttribute(this->_rxNameDescriptor);
+  this->_rxCharacteristic.setEventHandler(BLEWritten, BLEStream::_received);
+  addAttribute(this->_txCharacteristic);
+  addAttribute(this->_txNameDescriptor);
+}
+
+void BLEStream::begin(...)
+{
+  BLEPeripheral::begin();
+#ifdef BLE_SERIAL_DEBUG
+  Serial.println(F("BLEStream::begin()"));
+#endif
+}
+
+bool BLEStream::poll()
+{
+  // BLEPeripheral::poll is called each time connected() is called
+  this->_connected = BLEPeripheral::connected();
+  if (millis() > this->_flushed + this->_flushInterval) {
+    flush();
+  }
+  return this->_connected;
+}
+
+void BLEStream::end()
+{
+  this->_rxCharacteristic.setEventHandler(BLEWritten, NULL);
+  this->_rxHead = this->_rxTail = 0;
+  flush();
+  BLEPeripheral::disconnect();
+}
+
+int BLEStream::available(void)
+{
+// BLEPeripheral::poll only calls delay(1) in CurieBLE so skipping it here to avoid the delay
+#ifndef _VARIANT_ARDUINO_101_X_
+  // TODO Need to do more testing to determine if all of these calls to BLEPeripheral::poll are
+  // actually necessary. Seems to run fine without them, but only minimal testing so far.
+  BLEPeripheral::poll();
+#endif
+  int retval = (this->_rxHead - this->_rxTail + sizeof(this->_rxBuffer)) % sizeof(this->_rxBuffer);
+#ifdef BLE_SERIAL_DEBUG
+  if (retval > 0) {
+    Serial.print(F("BLEStream::available() = "));
+    Serial.println(retval);
+  }
+#endif
+  return retval;
+}
+
+int BLEStream::peek(void)
+{
+#ifndef _VARIANT_ARDUINO_101_X_
+  BLEPeripheral::poll();
+#endif
+  if (this->_rxTail == this->_rxHead) return -1;
+  uint8_t byte = this->_rxBuffer[this->_rxTail];
+#ifdef BLE_SERIAL_DEBUG
+  Serial.print(F("BLEStream::peek() = 0x"));
+  Serial.println(byte, HEX);
+#endif
+  return byte;
+}
+
+int BLEStream::read(void)
+{
+#ifndef _VARIANT_ARDUINO_101_X_
+  BLEPeripheral::poll();
+#endif
+  if (this->_rxTail == this->_rxHead) return -1;
+  this->_rxTail = (this->_rxTail + 1) % sizeof(this->_rxBuffer);
+  uint8_t byte = this->_rxBuffer[this->_rxTail];
+#ifdef BLE_SERIAL_DEBUG
+  Serial.print(F("BLEStream::read() = 0x"));
+  Serial.println(byte, HEX);
+#endif
+  return byte;
+}
+
+void BLEStream::flush(void)
+{
+  if (this->_txCount == 0) return;
+#ifndef _VARIANT_ARDUINO_101_X_
+  // ensure there are available packets before sending
+  while(!this->_txCharacteristic.canNotify()) {
+    BLEPeripheral::poll();
+  }
+#endif
+  this->_txCharacteristic.setValue(this->_txBuffer, this->_txCount);
+  this->_flushed = millis();
+  this->_txCount = 0;
+#ifdef BLE_SERIAL_DEBUG
+  Serial.println(F("BLEStream::flush()"));
+#endif
+}
+
+size_t BLEStream::write(uint8_t byte)
+{
+#ifndef _VARIANT_ARDUINO_101_X_
+  BLEPeripheral::poll();
+#endif
+  if (this->_txCharacteristic.subscribed() == false) return 0;
+  this->_txBuffer[this->_txCount++] = byte;
+  if (this->_txCount == sizeof(this->_txBuffer)) flush();
+#ifdef BLE_SERIAL_DEBUG
+  Serial.print(F("BLEStream::write( 0x"));
+  Serial.print(byte, HEX);
+  Serial.println(F(") = 1"));
+#endif
+  return 1;
+}
+
+BLEStream::operator bool()
+{
+  bool retval = this->_connected = BLEPeripheral::connected();
+#ifdef BLE_SERIAL_DEBUG
+  Serial.print(F("BLEStream::operator bool() = "));
+  Serial.println(retval);
+#endif
+  return retval;
+}
+
+void BLEStream::setFlushInterval(int interval)
+{
+  if (interval > BLESTREAM_MIN_FLUSH_INTERVAL) {
+    this->_flushInterval = interval;
+  }
+}
+
+void BLEStream::_received(const unsigned char* data, size_t size)
+{
+  for (size_t i = 0; i < size; i++) {
+    this->_rxHead = (this->_rxHead + 1) % sizeof(this->_rxBuffer);
+    this->_rxBuffer[this->_rxHead] = data[i];
+  }
+#ifdef BLE_SERIAL_DEBUG
+  Serial.print(F("BLEStream::received("));
+  for (int i = 0; i < size; i++) Serial.print(data[i], HEX);
+  Serial.println(F(")"));
+#endif
+}
+
+void BLEStream::_received(BLECentral& /*central*/, BLECharacteristic& rxCharacteristic)
+{
+  BLEStream::_instance->_received(rxCharacteristic.value(), rxCharacteristic.valueLength());
+}
+
+
+#endif // _BLE_STREAM_H_
Index: rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/EthernetClientStream.cpp
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/EthernetClientStream.cpp	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/EthernetClientStream.cpp	(revision 224)
@@ -0,0 +1,114 @@
+/*
+  EthernetClientStream.cpp
+  An Arduino-Stream that wraps an instance of Client reconnecting to
+  the remote-ip in a transparent way. A disconnected client may be
+  recognized by the returnvalues -1 from calls to peek or read and
+  a 0 from calls to write.
+
+  Copyright (C) 2013 Norbert Truchsess. All rights reserved.
+
+  This library is free software; you can redistribute it and/or
+  modify it under the terms of the GNU Lesser General Public
+  License as published by the Free Software Foundation; either
+  version 2.1 of the License, or (at your option) any later version.
+
+  See file LICENSE.txt for further informations on licensing terms.
+
+  formatted using the GNU C formatting and indenting
+ */
+
+#include "EthernetClientStream.h"
+#include <Arduino.h>
+
+//#define SERIAL_DEBUG
+#include "firmataDebug.h"
+
+#define MILLIS_RECONNECT 5000
+
+EthernetClientStream::EthernetClientStream(Client &client, IPAddress localip, IPAddress ip, const char* host, uint16_t port)
+: client(client),
+  localip(localip),
+  ip(ip),
+  host(host),
+  port(port),
+  connected(false)
+{
+}
+
+int
+EthernetClientStream::available()
+{
+  return maintain() ? client.available() : 0;
+}
+
+int
+EthernetClientStream::read()
+{
+  return maintain() ? client.read() : -1;
+}
+
+int
+EthernetClientStream::peek()
+{
+  return maintain() ? client.peek() : -1;
+}
+
+void EthernetClientStream::flush()
+{
+  if (maintain())
+    client.flush();
+}
+
+size_t
+EthernetClientStream::write(uint8_t c)
+{
+  return maintain() ? client.write(c) : 0;
+}
+
+void
+EthernetClientStream::maintain(IPAddress localip)
+{
+// temporary hack to Firmata to compile for Intel Galileo
+// the issue is documented here: https://github.com/firmata/arduino/issues/218
+#if !defined(ARDUINO_LINUX)
+  // ensure the local IP is updated in the case that it is changed by the DHCP server
+  if (this->localip != localip)
+    {
+      this->localip = localip;
+      if (connected)
+        stop();
+    }
+#endif
+}
+
+void
+EthernetClientStream::stop()
+{
+  client.stop();
+  connected = false;
+  time_connect = millis();
+}
+
+bool
+EthernetClientStream::maintain()
+{
+  if (client && client.connected())
+    return true;
+
+  if (connected)
+    {
+      stop();
+    }
+  // if the client is disconnected, attempt to reconnect every 5 seconds
+  else if (millis()-time_connect >= MILLIS_RECONNECT)
+    {
+      connected = host ? client.connect(host, port) : client.connect(ip, port);
+      if (!connected) {
+        time_connect = millis();
+        DEBUG_PRINTLN("connection failed. attempting to reconnect...");
+      } else {
+        DEBUG_PRINTLN("connected");
+      }
+    }
+  return connected;
+}
Index: rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/EthernetClientStream.h
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/EthernetClientStream.h	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/EthernetClientStream.h	(revision 224)
@@ -0,0 +1,52 @@
+/*
+  EthernetClientStream.h
+  An Arduino-Stream that wraps an instance of Client reconnecting to
+  the remote-ip in a transparent way. A disconnected client may be
+  recognized by the returnvalues -1 from calls to peek or read and
+  a 0 from calls to write.
+
+  Copyright (C) 2013 Norbert Truchsess. All rights reserved.
+
+  This library is free software; you can redistribute it and/or
+  modify it under the terms of the GNU Lesser General Public
+  License as published by the Free Software Foundation; either
+  version 2.1 of the License, or (at your option) any later version.
+
+  See file LICENSE.txt for further informations on licensing terms.
+
+  formatted using the GNU C formatting and indenting
+ */
+
+#ifndef ETHERNETCLIENTSTREAM_H
+#define ETHERNETCLIENTSTREAM_H
+
+#include <inttypes.h>
+#include <stdio.h>
+#include <Stream.h>
+#include <Client.h>
+#include <IPAddress.h>
+
+class EthernetClientStream : public Stream
+{
+public:
+  EthernetClientStream(Client &client, IPAddress localip, IPAddress ip, const char* host, uint16_t port);
+  int available();
+  int read();
+  int peek();
+  void flush();
+  size_t write(uint8_t);
+  void maintain(IPAddress localip);
+
+private:
+  Client &client;
+  IPAddress localip;
+  IPAddress ip;
+  const char* host;
+  uint16_t port;
+  bool connected;
+  uint32_t time_connect;
+  bool maintain();
+  void stop();
+};
+
+#endif
Index: rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/FirmataFeature.h
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/FirmataFeature.h	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/FirmataFeature.h	(revision 224)
@@ -0,0 +1,38 @@
+/*
+  FirmataFeature.h
+  Copyright (C) 2006-2008 Hans-Christoph Steiner.  All rights reserved.
+  Copyright (C) 2010-2011 Paul Stoffregen.  All rights reserved.
+  Copyright (C) 2009 Shigeru Kobayashi.  All rights reserved.
+  Copyright (C) 2013 Norbert Truchsess. All rights reserved.
+  Copyright (C) 2009-2016 Jeff Hoefs.  All rights reserved.
+
+  This library is free software; you can redistribute it and/or
+  modify it under the terms of the GNU Lesser General Public
+  License as published by the Free Software Foundation; either
+  version 2.1 of the License, or (at your option) any later version.
+
+  Interface for Firmata feature classes.
+
+  This version of FirmataFeature.h differs from the ConfigurableFirmata
+  version in the following ways:
+
+  - Imports Firmata.h rather than ConfigurableFirmata.h
+
+  See file LICENSE.txt for further informations on licensing terms.
+*/
+
+#ifndef FirmataFeature_h
+#define FirmataFeature_h
+
+#include <Firmata.h>
+
+class FirmataFeature
+{
+  public:
+    virtual void handleCapability(byte pin) = 0;
+    virtual boolean handlePinMode(byte pin, int mode) = 0;
+    virtual boolean handleSysex(byte command, byte argc, byte* argv) = 0;
+    virtual void reset() = 0;
+};
+
+#endif
